local _G = _G

local debugprofilestop = _G.debugprofilestop
local UnitMana = _G.UnitMana

local DEFAULT_CHAT_FRAME = _G.DEFAULT_CHAT_FRAME

local frame = CreateFrame("Frame")
frame:Hide()

frame.elapsed = 0
frame.prevMana = 0

frame:SetScript("OnEvent", function(self, event, unit)
    if unit == "player" then
        if event == "UNIT_MANA" then
            if self.waitForManaReduction and self.prevMana > UnitMana("player") then
                self.elapsed = debugprofilestop()
                DEFAULT_CHAT_FRAME:AddMessage("mp5 timer started...")
            else
                local elapsed = debugprofilestop()
                DEFAULT_CHAT_FRAME:AddMessage("elapsed: " .. (elapsed - self.elapsed) * 0.001 .. " seconds")
                self.elapsed = elapsed
            end
            self.waitForManaReduction = nil
        elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
            self.waitForManaReduction = true
            self.prevMana = UnitMana("player")
        end
    end
end)
frame:RegisterEvent("UNIT_MANA")
frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
